## stress-ng 0.15.06

=== Makefile ===
#
# Copyright (C) 2013-2021 Canonical, Ltd.
# Copyright (C) 2021-2023 Colin Ian King
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#

VERSION=0.15.06
#
# Codename "hegemonic huffy haddock"
#

CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"' -std=gnu99
#
# Default -O2 if optimization level not defined
#
ifeq "$(findstring -O,$(CFLAGS))" ""
	CFLAGS += -O2
endif

#
# Pedantic flags
#
ifeq ($(PEDANTIC),1)
CFLAGS += -Wcast-qual -Wfloat-equal -Wmissing-declarations \
	-Wmissing-format-attribute -Wno-long-long -Wpacked \
	-Wredundant-decls -Wshadow -Wno-missing-field-initializers \
	-Wno-missing-braces -Wno-sign-compare -Wno-multichar \
	-DHAVE_PEDANTIC
endif

#
# Test for hardening flags and apply them if applicable
#
MACHINE = $(shell uname -m)
ifneq ($(PRESERVE_CFLAGS),1)
ifneq ($(MACHINE),$(filter $(MACHINE),alpha parisc ia64))
ifeq ($(shell $(CC) $(CFLAGS) -fstack-protector-strong -E -xc /dev/null > /dev/null 2>& 1 && echo 1),1)
CFLAGS += -fstack-protector-strong
endif
endif
ifeq ($(shell $(CC) $(CFLAGS) -Werror=format-security -E -xc /dev/null > /dev/null 2>& 1 && echo 1),1)
CFLAGS += -Werror=format-security
endif
ifneq ($(findstring pcc,$(CC)),pcc)
ifeq ($(shell $(CC) $(CFLAGS) -D_FORTIFY_SOURCE=2 -E -xc /dev/null > /dev/null 2>& 1 && echo 1),1)
CFLAGS += -D_FORTIFY_SOURCE=2
endif
endif
endif

#
# Expected build warnings
#
ifeq ($(UNEXPECTED),1)
CFLAGS += -DCHECK_UNEXPECTED
endif

#
# Disable any user defined PREFV setting
#
ifneq ($(PRE_V),)
override undefine PRE_V
endif
#
# Verbosity prefixes
#
ifeq ($(VERBOSE),)
PRE_V=@
PRE_Q=@
else
PRE_V=
PRE_Q=@#
endif

ifneq ($(PRESERVE_CFLAGS),1)
ifeq ($(findstring icc,$(CC)),icc)
CFLAGS += -no-inline-max-size -no-inline-max-total-size
CFLAGS += -axAVX,CORE-AVX2,CORE-AVX-I,CORE-AVX512,SSE2,SSE3,SSSE3,SSE4.1,SSE4.2,SANDYBRIDGE,SKYLAKE,SKYLAKE-AVX512,TIGERLAKE,SAPPHIRERAPIDS
CFLAGS += -ip -falign-loops -funroll-loops -ansi-alias -fma -qoverride-limits
endif
endif

#ifeq ($(findstring clang,$(CC)),clang)
#CFLAGS += -Weverything
#endif

GREP = grep
#
# SunOS requires special grep for -e support
#
KERNEL=$(shell uname -s)
NODENAME=$(shell uname -n)
ifeq ($(KERNEL),SunOS)
ifneq ($(NODENAME),dilos)
GREP = /usr/xpg4/bin/grep
endif
endif

#
# Static flags, only to be used when using GCC
#
ifeq ($(STATIC),1)
LDFLAGS += -static -z muldefs
CFLAGS += -DBUILD_STATIC
endif

BINDIR=/usr/bin
MANDIR=/usr/share/man/man1
JOBDIR=/usr/share/stress-ng/example-jobs
BASHDIR=/usr/share/bash-completion/completions

#
# Header files
#
HEADERS = \
	core-arch.h \
	core-asm-arm.h \
	core-asm-ppc64.h \
	core-asm-riscv.h \
	core-asm-s390.h \
	core-asm-sparc.h \
	core-asm-x86.h \
	core-bitops.h \
	core-builtin.h \
	core-capabilities.h \
	core-cpu.h \
	core-cpu-cache.h \
	core-ftrace.h \
	core-hash.h \
	core-icache.h \
	core-io-priority.h \
	core-nt-load.h \
	core-nt-store.h \
	core-net.h \
	core-perf.h \
	core-pragma.h \
	core-pthread.h \
	core-put.h \
	core-resources.h \
	core-smart.h \
	core-sort.h \
	core-stressors.h \
	core-syslog.h \
	core-target-clones.h \
	core-thermal-zone.h \
	core-thrash.h \
	core-vecmath.h \
	core-version.h \
	stress-af-alg-defconfigs.h \
	stress-ng.h

#
#  Build time generated header files
#
HEADERS_GEN = \
	config.h \
	git-commit-id.h \
	io-uring.h \
	personality.h

#
#  Stressors
#
STRESS_SRC = \
	stress-access.c \
	stress-affinity.c \
	stress-af-alg.c \
	stress-aio.c \
	stress-aiol.c \
	stress-alarm.c \
	stress-apparmor.c \
	stress-atomic.c \
	stress-bad-altstack.c \
	stress-bad-ioctl.c \
	stress-bigheap.c \
	stress-bind-mount.c \
	stress-binderfs.c \
	stress-branch.c \
	stress-brk.c \
	stress-bsearch.c \
	stress-cache.c \
	stress-cacheline.c \
	stress-cap.c \
	stress-chattr.c \
	stress-chdir.c \
	stress-chmod.c \
	stress-chown.c \
	stress-chroot.c \
	stress-clock.c \
	stress-clone.c \
	stress-close.c \
	stress-context.c \
	stress-copy-file.c \
	stress-cpu.c \
	stress-cpu-online.c \
	stress-crypt.c \
	stress-cyclic.c \
	stress-daemon.c \
	stress-dccp.c \
	stress-dekker.c \
	stress-dentry.c \
	stress-dev.c \
	stress-dev-shm.c \
	stress-dir.c \
	stress-dirdeep.c \
	stress-dirmany.c \
	stress-dnotify.c \
	stress-dup.c \
	stress-dynlib.c \
	stress-efivar.c \
	stress-enosys.c \
	stress-env.c \
	stress-epoll.c \
	stress-eventfd.c \
	stress-exec.c \
	stress-exit-group.c \
	stress-fallocate.c \
	stress-fanotify.c \
	stress-far-branch.c \
	stress-fault.c \
	stress-fcntl.c \
	stress-file-ioctl.c \
	stress-fiemap.c \
	stress-fifo.c \
	stress-filename.c \
	stress-flock.c \
	stress-flushcache.c \
	stress-fork.c \
	stress-forkheavy.c \
	stress-fp.c \
	stress-fp-error.c \
	stress-fpunch.c \
	stress-fsize.c \
	stress-fstat.c \
	stress-full.c \
	stress-funccall.c \
	stress-funcret.c \
	stress-futex.c \
	stress-get.c \
	stress-getrandom.c \
	stress-getdent.c \
	stress-goto.c \
	stress-gpu.c \
	stress-handle.c \
	stress-hash.c \
	stress-hdd.c \
	stress-heapsort.c \
	stress-hrtimers.c \
	stress-hsearch.c \
	stress-icache.c \
	stress-icmp-flood.c \
	stress-idle-page.c \
	stress-inode-flags.c \
	stress-inotify.c \
	stress-io.c \
	stress-iomix.c \
	stress-ioport.c \
	stress-ioprio.c \
	stress-io-uring.c \
	stress-ipsec-mb.c \
	stress-itimer.c \
	stress-jpeg.c \
	stress-judy.c \
	stress-kcmp.c \
	stress-key.c \
	stress-kill.c \
	stress-klog.c \
	stress-kvm.c \
	stress-l1cache.c \
	stress-landlock.c \
	stress-lease.c \
	stress-link.c \
	stress-list.c \
	stress-llc-affinity.c \
	stress-loadavg.c \
	stress-lockbus.c \
	stress-locka.c \
	stress-lockf.c \
	stress-lockofd.c \
	stress-longjmp.c \
	stress-loop.c \
	stress-lsearch.c \
	stress-madvise.c \
	stress-malloc.c \
	stress-matrix.c \
	stress-matrix-3d.c \
	stress-mcontend.c \
	stress-membarrier.c \
	stress-memcpy.c \
	stress-memfd.c \
	stress-memhotplug.c \
	stress-memrate.c \
	stress-memthrash.c \
	stress-mergesort.c \
	stress-mincore.c \
	stress-misaligned.c \
	stress-mknod.c \
	stress-mlock.c \
	stress-mlockmany.c \
	stress-mmap.c \
	stress-mmapaddr.c \
	stress-mmapfixed.c \
	stress-mmapfork.c \
	stress-mmaphuge.c \
	stress-mmapmany.c \
	stress-mprotect.c \
	stress-mq.c \
	stress-mremap.c \
	stress-msg.c \
	stress-msync.c \
	stress-msyncmany.c \
	stress-munmap.c \
	stress-mutex.c \
	stress-nanosleep.c \
	stress-netdev.c \
	stress-netlink-proc.c \
	stress-netlink-task.c \
	stress-nice.c \
	stress-nop.c \
	stress-null.c \
	stress-numa.c \
	stress-oom-pipe.c \
	stress-opcode.c \
	stress-open.c \
	stress-pagemove.c \
	stress-pageswap.c \
	stress-pci.c \
	stress-personality.c \
	stress-peterson.c \
	stress-physpage.c \
	stress-pidfd.c \
	stress-ping-sock.c \
	stress-pipe.c \
	stress-pipeherd.c \
	stress-pkey.c \
	stress-plugin.c \
	stress-poll.c \
	stress-prctl.c \
	stress-prefetch.c \
	stress-priv-instr.c \
	stress-procfs.c \
	stress-pthread.c \
	stress-ptrace.c \
	stress-pty.c \
	stress-quota.c \
	stress-qsort.c \
	stress-race-sched.c \
	stress-radixsort.c \
	stress-randlist.c \
	stress-ramfs.c \
	stress-rawdev.c \
	stress-rawpkt.c \
	stress-rawsock.c \
	stress-rawudp.c \
	stress-rdrand.c \
	stress-readahead.c \
	stress-reboot.c \
	stress-regs.c \
	stress-remap.c \
	stress-rename.c \
	stress-resched.c \
	stress-resources.c \
	stress-revio.c \
	stress-ring-pipe.c \
	stress-rlimit.c \
	stress-rmap.c \
	stress-rotate.c \
	stress-rseq.c \
	stress-rtc.c \
	stress-sctp.c \
	stress-schedpolicy.c \
	stress-seal.c \
	stress-seccomp.c \
	stress-secretmem.c \
	stress-seek.c \
	stress-sem.c \
	stress-sem-sysv.c \
	stress-sendfile.c \
	stress-session.c \
	stress-set.c \
	stress-shellsort.c \
	stress-shm.c \
	stress-shm-sysv.c \
	stress-sigabrt.c \
	stress-sigchld.c \
	stress-sigfd.c \
	stress-sigfpe.c \
	stress-sigio.c \
	stress-signal.c \
	stress-signest.c \
	stress-sigpending.c \
	stress-sigpipe.c \
	stress-sigq.c \
	stress-sigrt.c \
	stress-sigsegv.c \
	stress-sigsuspend.c \
	stress-sigtrap.c \
	stress-skiplist.c \
	stress-sleep.c \
	stress-smi.c \
	stress-sock.c \
	stress-sockabuse.c \
	stress-sockdiag.c \
	stress-sockfd.c \
	stress-sockpair.c \
	stress-sockmany.c \
	stress-softlockup.c \
	stress-spawn.c \
	stress-sparsematrix.c \
	stress-splice.c \
	stress-stack.c \
	stress-stackmmap.c \
	stress-str.c \
	stress-stream.c \
	stress-swap.c \
	stress-switch.c \
	stress-sync-file.c \
	stress-syncload.c \
	stress-sysbadaddr.c \
	stress-syscall.c \
	stress-sysinfo.c \
	stress-sysinval.c \
	stress-sysfs.c \
	stress-tee.c \
	stress-timer.c \
	stress-timerfd.c \
	stress-tlb-shootdown.c \
	stress-tmpfs.c \
	stress-touch.c \
	stress-tree.c \
	stress-tsc.c \
	stress-tsearch.c \
	stress-tun.c \
	stress-udp.c \
	stress-udp-flood.c \
	stress-umount.c \
	stress-unshare.c \
	stress-uprobe.c \
	stress-urandom.c \
	stress-userfaultfd.c \
	stress-usersyscall.c \
	stress-utime.c \
	stress-vdso.c \
	stress-vecfp.c \
	stress-vecmath.c \
	stress-vecshuf.c \
	stress-vecwide.c \
	stress-verity.c \
	stress-vforkmany.c \
	stress-vm.c \
	stress-vm-addr.c \
	stress-vm-rw.c \
	stress-vm-segv.c \
	stress-vm-splice.c \
	stress-wait.c \
	stress-waitcpu.c \
	stress-watchdog.c \
	stress-wcs.c \
	stress-x86cpuid.c \
	stress-x86syscall.c \
	stress-xattr.c \
	stress-yield.c \
	stress-zero.c \
	stress-zlib.c \
	stress-zombie.c \

#
# Stress core
#
CORE_SRC = \
	core-affinity.c \
	core-cpu.c \
	core-cpu-cache.c \
	core-hash.c \
	core-helper.c \
	core-icache.c \
	core-ignite-cpu.c \
	core-io-uring.c \
	core-io-priority.c \
	core-job.c \
	core-killpid.c \
	core-klog.c \
	core-limit.c \
	core-lock.c \
	core-log.c \
	core-madvise.c \
	core-mincore.c \
	core-mlock.c \
	core-mmap.c \
	core-module.c \
	core-mounts.c \
	core-mwc.c \
	core-net.c \
	core-numa.c \
	core-out-of-memory.c \
	core-parse-opts.c \
	core-perf.c \
	core-resources.c \
	core-sched.c \
	core-setting.c \
	core-shared-heap.c \
	core-shim.c \
	core-smart.c \
	core-sort.c \
	core-thermal-zone.c \
	core-time.c \
	core-thrash.c \
	core-ftrace.c \
	core-try-open.c \
	core-vmstat.c \
	stress-ng.c

SRC = $(CORE_SRC) $(STRESS_SRC)
OBJS = apparmor-data.o
OBJS += $(SRC:.c=.o)

APPARMOR_PARSER=/sbin/apparmor_parser

all: config.h stress-ng

.SUFFIXES: .c .o

.o: Makefile

%.o: %.c $(HEADERS) $(HEADERS_GEN)
	$(PRE_Q)echo "CC $<"
	$(PRE_V)$(CC) $(CFLAGS) -c -o $@ $<

stress-ng: config.h $(OBJS)
	$(PRE_Q)echo "LD $@"
	$(eval LDFLAGS_EXTRA := $(shell cat config | grep CONFIG_LDFLAGS | sed 's/CONFIG_LDFLAGS += //' | tr '\n' ' '))
	$(PRE_V)$(CC) $(CPPFLAGS) $(CFLAGS) $(OBJS) -lm $(LDFLAGS) $(LDFLAGS_EXTRA) -o $@

config.h config:
	$(PRE_Q)echo "Generating config.."
	$(MAKE) CC="$(CC)" STATIC=$(STATIC) -f Makefile.config

makeconfig: config.h

#
#  generate apparmor data using minimal core utils tools from apparmor
#  parser output
#
apparmor-data.o: usr.bin.pulseaudio.eg config.h
	$(PRE_Q)rm -f apparmor-data.bin
	$(PRE_V)if [ -n "$(shell grep '^#define HAVE_APPARMOR' config.h)" ]; then \
		echo "Generating AppArmor profile from usr.bin.pulseaudio.eg"; \
		$(APPARMOR_PARSER) -Q usr.bin.pulseaudio.eg  -o apparmor-data.bin >/dev/null 2>&1 ; \
	else \
		echo "Generating empty AppArmor profile"; \
		touch apparmor-data.bin; \
	fi
	$(PRE_V)echo "#include <stddef.h>" > apparmor-data.c
	$(PRE_V)echo "char g_apparmor_data[]= { " >> apparmor-data.c
	$(PRE_V)od -tx1 -An -v < apparmor-data.bin | \
		sed 's/[0-9a-f][0-9a-f]/0x&,/g' | \
		sed '$$ s/.$$//' >> apparmor-data.c
	$(PRE_V)echo "};" >> apparmor-data.c
	$(PRE_V)rm -f apparmor-data.bin

=== debian/changelog ===
stress-ng (0.15.06-2) unstable; urgency=medium

  * Fix random buffer filling issue
    - 0001-core-helper-fix-stress_rndbuf-to-fill-entire-buff.patch
  * Re-enable af-alg stressor if ipsec-mb is not available
    - 0002-stress-af-alg-remove-check-for-HAVE_LIB_IPSEC_MB.patch

 -- Colin Ian King <colin.i.king@gmail.com>  Mon, 20 Mar 2023 09:43:11 +0000

stress-ng (0.15.06-1) unstable; urgency=medium

  * Makefile: bump version
  * README.md: add another citation
  * Manual: update date
  * debian/testing/fast-test-all: remove --klog-check
  * stress-ng: fix truncated pr_inf call
  * stress-ng: add --oom-avoid-bytes option for the free memory avoid
    allocation threshold
  * stress-cache: remove % operator, using compare and re-assign to zero
  * stess-msg: add --msg-bytes option to specify size of message being
    sent/recv'd
  * stress-msg: voidify return of msgctl
  * stress-*, test-*: remove trailing spaces at end of lines
  * stress-shm-sysv: define SHM_HUGE_* macros if required, drop IPC_PRIVATE
    error check
  * stress-shm-sysv: add SHM_HUGE_2MB flag when using SHM_HUGETLB
  * stess-shm-sysv: plumb in --sym-sysv-bytes option to correct ID
  * stress-shm-sysv: replace IPC_RMID with IPC_PRIVATE in error message
  * stress-shm-sysv: add missing space in error message
  * stress-cyclic: report the number of samples required for the test run
  * stress-memrate: make vector types based on uint32_t, add prefetch 128
  * stress-memrate: make prefetch offset 2K
  * stress-memrate: remove inner loops for non-memory rate timed functions
  * stress-memrate: remove keep_stressing check, use siglongjmp in alarm
    handler
  * stress-memrate: add in further loop optimizations
  * stress-vm: explicitly add modulo inline helper function
  * core-helper: add stress_get_prime64 to get prime above a given value
  * core-helper: rename stress_get_prime64 to stress_get_next_prime64
  * stress-memrate: fix --memrate-wr-mbs/rd-mbs, use best fit size, add
    memset writes too
  * stress-vm: skip stressor when out of resources, return EXIT_NO_RESOURCES
  * stress-vm: fix prime index accumulation overflow and speed up modulo
  * stress-vm: compute a new prime that is larger than sz rather than use
    PRIME_64

 -- Colin Ian King <colin.i.king@gmail.com>  Thu, 16 Mar 2023 12:47:17 +0000

stress-ng (0.15.05-1) unstable; urgency=medium

  [Erik Stahlman]
  * Populate jmp_env before it could be used

  [Julien Olivain]
  * Makefile: introduce PRESERVE_CFLAGS build flag
  * stress-regs: fix build on riscv32
  * stress-mmap: fix build with HAVE_SYSCALL or __NR_mmap2 is undefined

  [Colin Ian King]
  * Makefile: bump version
  * Manual: simplify the contributors text and put a link to the README.md
    file
  * README.md: add contributors
  * README.md: update notes about icc, icx and musl-gcc
  * stress-ng.h: disable fast math for icc, it's not supported yet
  * core-pragma: generalize unroll n to unroll for Intel icc compiler
  * Manual: add bold notes about using bogo-ops as a benchmarking metric
  * stress-pthread: call sys_set_robust_list using copy of head on
    the stack
  * stress-pthread: disable set_robust_list calls
  * stress-mremap: pass an illegal remapping address rather than null
  * core-pragma: bump clang version for STRESS_PRAGMA_WARN_CPP_OFF
  * core-pragma: define STRESS_PRAGMA_WARN_CPP_OFF for different compiler
   versions
  * stress-qsort: cast return of mmap to same type as data
  * stress-ng: only define OPTIMIZE_FAST_MAST with fast math attribute
    for gcc 10+
  * stress-brk: voidify two more args to clean up OS X build warning
  * stress-brk: clean up OS X build warning
  * stress-lockbus: enable for tested targets
  * stress-lockbus: enable riscv
  * stress-lock: try alternative __atomic_fetch_add if add_fetch is not
    available
  * stress-cpu: collatz: force compiler to generate collatz computation
  * stress-cpu: explog: add randomness, stash intermediates to force exp
    and log calls
  * stress-cpu: add some randomness to force code generation of
    computation
  * Makefile: fix typo, remove i after parisc
  * stress-tee: use correct format specifiers for size_t values
  * stress-chown: fix incorrect goto before zero ret check
  * Avoid division by zero
  * stress-cache: fix incorrect variable being passed to cache helper
    functions
  * stress-zero: exercise a couple of ioctls
  * stress-full: exercise a couple of ioctls
  * stress-shellsort: remove 8 bit sort, replace it with 32 bit mangling
  * stress-mergesort: remove 64 bit sort, replace it with 32 bit mangling
  * stress-heapsort: remove 8 bit sort, replace it with 32 bit mangling
  * core-sort: move stress_sort_data_int32_mangle from stress-qsort to
    core-sort
  * stress-rtc: add const to * ptr
  * stress-rmap: add yield check, helps BSD systems when touching many
    pages
  * stress-evivar: use a lookup table for names to ignore
  * stress-l1cache: add a l1cache method to select forward, random or
    reverse cache exercising
  * stress-wcs: remove redundant forward declaration of wcs
  * stress-str: remove redundant forward declaration of metrics
  * stress-x86cpuid: reduce scope of variables eax, ebx, ecx and edx
  * test/test-timerfd-create: remove unused variable fd
  * stress-vm-rw: memset stack to zero to silence pedantic static
    analyzers
  * stress-vdso: reduce scope of variable str
  * stress-ng: reduce scope of variable ret
  * stress-shm-sysv: rename sz to shmmax and add it to error message
  * stress-sigio: reduce scope of buffer
  * stress-rawdev: reduce scope of rate, constify rate and duration
  * stress-prctl: change scope of declaration of ret
  * stress-prctl: voidify ret
  * stress-mutex: only declare cpus if (HAVE_PTHREAD_SETAFFINITY_NP is
    defined
  * stress-ipsec-mb: move declaration of ptr into context that uses it
  * stress-cyclic: rename noclobber rc to ncrc
  * core-vmstat: move variables into more local context


=== debian/control ===
Source: stress-ng
Rules-Requires-Root: no
Section: devel
Priority: optional
Maintainer: Colin Ian King <colin.i.king@gmail.com>
Standards-Version: 4.6.2
Build-Depends: debhelper (>= 13),
               debhelper-compat (=13),
               zlib1g-dev,
               libbsd-dev,
               libgcrypt20-dev,
               libjpeg-dev,
               libkeyutils-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64 !linux-ia64],
               libapparmor-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64],
               apparmor [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64],
               libaio-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64],
               libcap-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64],
               libsctp-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64],
               libipsec-mb-dev [amd64],
               libjudy-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64],
               libatomic1 [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64],
               libkmod-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64],
               libxxhash-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64],
               libglvnd-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64],
               libgbm-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64]

Homepage: https://github.com/ColinIanKing/stress-ng
Package: stress-ng
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: tool to load and stress a computer
 stress-ng can stress various subsystems of a computer.  It can stress load
 CPU, cache, disk, memory, socket and pipe I/O, scheduling and much more.
 stress-ng is a re-write of the original stress tool by Amos Waterland but
 has many additional features such as specifying the number of bogo operations
 to run, execution metrics, a stress verification on memory and compute
 operations and considerably more stress mechanisms.

## stress-ng 0.16.02

=== Makefile ===
--- 
+++ 
@@ -17,10 +17,13 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 #
 
-VERSION=0.15.06
-#
-# Codename "hegemonic huffy haddock"
-#
+VERSION=0.16.02
+#
+# Codename "capable cache cruncher"
+#
+
+KERNEL=$(shell uname -s)
+NODENAME=$(shell uname -n)
 
 CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"' -std=gnu99
 #
@@ -56,7 +59,7 @@
 endif
 ifneq ($(findstring pcc,$(CC)),pcc)
 ifeq ($(shell $(CC) $(CFLAGS) -D_FORTIFY_SOURCE=2 -E -xc /dev/null > /dev/null 2>& 1 && echo 1),1)
-CFLAGS += -D_FORTIFY_SOURCE=2
+CFLAGS += -U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=2
 endif
 endif
 endif
@@ -93,6 +96,12 @@
 endif
 endif
 
+ifeq ($(findstring gcc,$(CC)),gcc)
+ifneq ($(KERNEL),SunOS)
+CFLAGS += -ftree-loop-vectorize
+endif
+endif
+
 #ifeq ($(findstring clang,$(CC)),clang)
 #CFLAGS += -Weverything
 #endif
@@ -101,8 +110,6 @@
 #
 # SunOS requires special grep for -e support
 #
-KERNEL=$(shell uname -s)
-NODENAME=$(shell uname -n)
 ifeq ($(KERNEL),SunOS)
 ifneq ($(NODENAME),dilos)
 GREP = /usr/xpg4/bin/grep
@@ -160,6 +167,7 @@
 	core-vecmath.h \
 	core-version.h \
 	stress-af-alg-defconfigs.h \
+	stress-eigen-ops.h \
 	stress-ng.h
 
 #
@@ -220,6 +228,7 @@
 	stress-dnotify.c \
 	stress-dup.c \
 	stress-dynlib.c \
+	stress-eigen.c \
 	stress-efivar.c \
 	stress-enosys.c \
 	stress-env.c \
@@ -238,6 +247,7 @@
 	stress-filename.c \
 	stress-flock.c \
 	stress-flushcache.c \
+	stress-fma.c \
 	stress-fork.c \
 	stress-forkheavy.c \
 	stress-fp.c \
@@ -316,7 +326,9 @@
 	stress-mmapfork.c \
 	stress-mmaphuge.c \
 	stress-mmapmany.c \
+	stress-module.c \
 	stress-mprotect.c \
+	stress-mpfr.c \
 	stress-mq.c \
 	stress-mremap.c \
 	stress-msg.c \
@@ -488,6 +500,7 @@
 	core-helper.c \
 	core-icache.c \
 	core-ignite-cpu.c \
+	core-interrupts.c \
 	core-io-uring.c \
 	core-io-priority.c \
 	core-job.c \
@@ -508,6 +521,7 @@
 	core-out-of-memory.c \
 	core-parse-opts.c \
 	core-perf.c \
+	core-processes.c \
 	core-resources.c \
 	core-sched.c \
 	core-setting.c \
@@ -525,13 +539,14 @@
 
 SRC = $(CORE_SRC) $(STRESS_SRC)
 OBJS = apparmor-data.o
+OBJS += stress-eigen-ops.o
 OBJS += $(SRC:.c=.o)
 
 APPARMOR_PARSER=/sbin/apparmor_parser
 
 all: config.h stress-ng
 
-.SUFFIXES: .c .o
+.SUFFIXES: .cpp .c .o
 
 .o: Makefile
 
@@ -539,10 +554,23 @@
 	$(PRE_Q)echo "CC $<"
 	$(PRE_V)$(CC) $(CFLAGS) -c -o $@ $<
 
+#
+#  Use CC for linking if eigen is not being used, otherwise use CXX
+#
 stress-ng: config.h $(OBJS)
 	$(PRE_Q)echo "LD $@"
+	$(eval LINK_TOOL := $(shell if [ -n "$(shell grep '^#define HAVE_EIGEN' config.h)" ]; then echo $(CXX); else echo $(CC); fi))
 	$(eval LDFLAGS_EXTRA := $(shell cat config | grep CONFIG_LDFLAGS | sed 's/CONFIG_LDFLAGS += //' | tr '\n' ' '))
-	$(PRE_V)$(CC) $(CPPFLAGS) $(CFLAGS) $(OBJS) -lm $(LDFLAGS) $(LDFLAGS_EXTRA) -o $@
+	$(PRE_V)$(LINK_TOOL) $(OBJS) -lm $(LDFLAGS) $(LDFLAGS_EXTRA) -o $@
+
+stress-eigen-ops.o: config.h
+	@if grep -q '^#define HAVE_EIGEN' config.h; then \
+		echo "CXX stress-eigen-ops.cpp";	\
+		$(CXX) -c -o stress-eigen-ops.o stress-eigen-ops.cpp; \
+	else \
+		echo "CC stress-eigen-ops.c";	\
+		$(CC) -c -o stress-eigen-ops.o stress-eigen-ops.c; \
+	fi
 
 config.h config:
 	$(PRE_Q)echo "Generating config.."
@@ -552,21 +580,3 @@
 
 #
 #  generate apparmor data using minimal core utils tools from apparmor
-#  parser output
-#
-apparmor-data.o: usr.bin.pulseaudio.eg config.h
-	$(PRE_Q)rm -f apparmor-data.bin
-	$(PRE_V)if [ -n "$(shell grep '^#define HAVE_APPARMOR' config.h)" ]; then \
-		echo "Generating AppArmor profile from usr.bin.pulseaudio.eg"; \
-		$(APPARMOR_PARSER) -Q usr.bin.pulseaudio.eg  -o apparmor-data.bin >/dev/null 2>&1 ; \
-	else \
-		echo "Generating empty AppArmor profile"; \
-		touch apparmor-data.bin; \
-	fi
-	$(PRE_V)echo "#include <stddef.h>" > apparmor-data.c
-	$(PRE_V)echo "char g_apparmor_data[]= { " >> apparmor-data.c
-	$(PRE_V)od -tx1 -An -v < apparmor-data.bin | \
-		sed 's/[0-9a-f][0-9a-f]/0x&,/g' | \
-		sed '$$ s/.$$//' >> apparmor-data.c
-	$(PRE_V)echo "};" >> apparmor-data.c
-	$(PRE_V)rm -f apparmor-data.bin

=== debian/changelog ===
stress-ng (0.16.02-1) unstable; urgency=medium

  * Makefile: bump version again
  * stress-cyclic: Fix segv caused by uninitialized variable cyclic_method
  * README.md: add repology information

 -- Colin Ian King <colin.i.king@gmail.com>  Thu, 13 Jul 2023 08:44:47 +0100

stress-ng (0.16.01-1) unstable; urgency=medium

  [ Pino Toscano ]
  * debian/control: Update/improve the build dependencies (Closes: #1040582)
    - enable libkeyutils-dev also on ia64, as it is available there as well
    - enable libjudy-dev, libxxhash-dev, and libglvnd-dev on all the
      architectures, as they are not specific to a certain OS
    - switch the build dependencies that exist only on Linux from
      "!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64" to "linux-any":
      libkeyutils-dev, libapparmor-dev, apparmor, libaio-dev, libcap-dev,
      libsctp-dev, libatomic1, libkmod-dev, libgbm-dev

  [ Colin Ian King ]
  * Makefile: bump version
  * Manual: update date
  * stress-shm-sysv: abort early if we run out of shm resources
  * stress-hash: fix index overrun during initialization
  * stress-hash: fix index overrun in stress_hash_all
  * stress-nop: add NOCLOBBER to pointer instr, clear Solaris gcc 4.8.2
    warning
  * stress-ng: fix sigprocmask, signals that need to be blocked are set,
    not zero'd
  * stress-bad-ioctl: replace next label with continue statement
  * core-setting: remove TYPE_ID_UINTPTR_T type
  * stress-zlib: replace null check in methods array with length check
  * stress-vm: replace null check in methods array with length check
  * stress-vm-addr: replace null check in methods array with length check
  * stress-switch: replace null check in methods array with length check
  * stress-sparsematrix: replace null check in methods array with length
    check
  * stress-opcode: replace null check in methods array with array length
    check
  * stress-misaligned: replace null check in methods array with length
    check
  * stress-cyclic: pass address of pointer rather than method address
  * stress-memcpy: replace null check in methods array with length check
  * stress-hash: replace null check in methods array with length check
  * stress-exec: replace null check in methods array with length check
  * stress-cyclic: replace null check in cyclic_methods with length check
  * stress-cpu: replace null check in cpu_methods with length check
  * Manual: fix typo in --cpu-offline-all option
  * Manual: some minor grammar changes
  * stress-ng: add --status N option to report stressor runs status every
    N seconds
  * stress-malloc: remove need for some global variables, clean up code
  * stress-schedpolicy: add --schedpolicy-rand option to select policy
    randomly
  * stress-bad-ioctl: fix fd leak
  * stress-chroot: add two standard methods of breaking out of a chroot
    as tests
  * stress-bad-ioctl: add --bad-ioctl-method to select how ioctl commands
    are changed
  * stress-stream: ensure number of elements is a multiple of unroll size
  * stress-ng: make child termination SIGALRM messages debug only
  * stress-ng: speed up child termination by blocking signals and skip
    excessive free'ing

 -- Colin Ian King <colin.i.king@gmail.com>  Tue, 11 Jul 2023 11:24:12 +0100

stress-ng (0.16.00-1) unstable; urgency=medium

  * Makefile: bump version to 0.16.00
  * core-helper: double size of temporary string buffer tmp
  * stress-ipsec-mb: use reverse compat macros for versions 0.55.00
  * stress-ipsec-mb: add reverse compat macros for version 0.52.0 or
    earlier
  * Manual: fix eigen table
  * stress-mlock: clean up pedantic warning on uninitialized pointer
    mappings
  * stress-cache: clean up longjmp clobber warnings on openhipster 202104
  * stress-mmap: check for NetBSD EPERM errors on page protection checks
  * stress-far-branch: disabled for NetBSD
  * stress-iomix: shrink file size if we hit EFBIG or ENOSPC
  * stress-copyfile: handle ENOSYS by skipping stressor
  * stress-misaligned: handle timeout by jmping back and restarting
  * kernel-coverage.sh: add more mlock options
  * README.md: fix ClearLinux libattr bundle name
  * stress-pagemove: add new --pagemove-mlock option
  * stress-memfd: add new --mefd-mlock option
  * stress-malloc: add new --malloc-mlock option
  * stress-llc-affinity: add new --llc-affinity-mlock option
  * kernel-coverage: add some more stressor options for more coverage
  * stress-physpage: voidify physpage_mtrr when not used
  * stress-bad-altstack: return EXIT_FAILURE insted of
    _exit(EXIT_FAILURE)
  * core-parse-opts: return 0 on err, clean up pedantic tcc warnings
  * stress-ng.h: undef _FORTIFY_SOURCE for TCC builds
  * core-killpid: break out of infinite loop and return via return path
  * stress-af-alg: add hmac(md5) to defconfigs
  * core-helper: add detection for Darwin libc
  * core-vmstat: clean up pedantic warning on const name array on OS X
  * stress-madvise: voidify hwpoison
  * stress-x86syscall: rename variables to avoid name shadowing
  * stress-open: remove shadowing variable ret
  * Manual: re-order options into alphabetical order, fix some hyphens
  * Manual: remove expand from tables now that x is being used
  * Manual: put code examples in courier font
  * Manual: use lx expand description in tables
  * Manual: add notes about the legacy io stressor
  * README.md: add another citation
  * Manual: remove x86 specific notes for icache stressor
  * stress-mmapaddr: remove trailing space
  * Manual: rephrase mlock options
  * stress-vm-addr: add new --vm-addr-mlock option
  * stress-waitcpu: only perform nop rate comparisons of x86
  * stress-stream: add new --stream-mlock option
  * stress-shm-sysv: add new --shm-sysv-mlock option
  * stress-shm: add new --shm-mlock option
  * stress-remap: add new --remap-mlock option
  * stress-resources: add new --resources-mlock option
  * stress-mmapmany: add new --mmapmany-mlock option
  * stress-mmaphuge: add new --mmaphuge-mlock option


## stress-ng 0.17.05

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #
 # Copyright (C) 2013-2021 Canonical, Ltd.
-# Copyright (C) 2021-2023 Colin Ian King
+# Copyright (C) 2021-2024 Colin Ian King
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -17,31 +17,58 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 #
 
-VERSION=0.16.02
-#
-# Codename "capable cache cruncher"
+VERSION=0.17.05
+#
+# Codename "scintillating scheduler smasher"
 #
 
 KERNEL=$(shell uname -s)
 NODENAME=$(shell uname -n)
 
-CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"' -std=gnu99
+override CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"' -std=gnu99
+
+#
+#  Building stress-vnni with less than -O2 causes breakage with
+#  gcc-13.2, so remove then and ensure at least -O2 is used or
+#  honour flags > -O2 if they are provided
+#
+VNNI_OFLAGS_REMOVE=-O0 -O1 -Og
+VNNI_CFLAGS += $(filter-out $(VNNI_OFLAGS_REMOVE),$(CFLAGS))
+
 #
 # Default -O2 if optimization level not defined
 #
 ifeq "$(findstring -O,$(CFLAGS))" ""
-	CFLAGS += -O2
-endif
+	override CFLAGS += -O2
+endif
+ifeq "$(findstring -O,$(VNNI_CFLAGS))" ""
+	override VNNI_CFLAGS += -O2
+endif
+
+#
+# Debug flag
+#
+ifeq ($(DEBUG),1)
+override CFLAGS += -g
+endif
+
+#
+# Check if compiler supports flag set in $(flag)
+#
+cc_supports_flag = $(shell $(CC) -Werror $(flag) -E -xc /dev/null > /dev/null 2>&1 && echo $(flag))
 
 #
 # Pedantic flags
 #
 ifeq ($(PEDANTIC),1)
-CFLAGS += -Wcast-qual -Wfloat-equal -Wmissing-declarations \
+
+PEDANTIC_FLAGS := \
+	-Wcast-qual -Wfloat-equal -Wmissing-declarations \
 	-Wmissing-format-attribute -Wno-long-long -Wpacked \
 	-Wredundant-decls -Wshadow -Wno-missing-field-initializers \
 	-Wno-missing-braces -Wno-sign-compare -Wno-multichar \
 	-DHAVE_PEDANTIC
+override CFLAGS += $(foreach flag,$(PEDANTIC_FLAGS),$(cc_supports_flag))
 endif
 
 #
@@ -50,25 +77,31 @@
 MACHINE = $(shell uname -m)
 ifneq ($(PRESERVE_CFLAGS),1)
 ifneq ($(MACHINE),$(filter $(MACHINE),alpha parisc ia64))
-ifeq ($(shell $(CC) $(CFLAGS) -fstack-protector-strong -E -xc /dev/null > /dev/null 2>& 1 && echo 1),1)
-CFLAGS += -fstack-protector-strong
-endif
-endif
-ifeq ($(shell $(CC) $(CFLAGS) -Werror=format-security -E -xc /dev/null > /dev/null 2>& 1 && echo 1),1)
-CFLAGS += -Werror=format-security
-endif
-ifneq ($(findstring pcc,$(CC)),pcc)
-ifeq ($(shell $(CC) $(CFLAGS) -D_FORTIFY_SOURCE=2 -E -xc /dev/null > /dev/null 2>& 1 && echo 1),1)
-CFLAGS += -U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=2
-endif
-endif
+flag = -Wformat -fstack-protector-strong \
+	-U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=2 \
+	-Werror=format-security
+override CFLAGS += $(cc_supports_flag)
+endif
+endif
+
+#
+# Optimization flags
+#
+ifeq ($(findstring icc,$(CC)),)
+override CFLAGS += $(foreach flag,-fipa-pta,$(cc_supports_flag))
+endif
+#
+# Enable Link Time Optimization
+#
+ifeq ($(LTO),1)
+override CFLAGS += $(foreach flag,-flto=auto,$(cc_supports_flag))
 endif
 
 #
 # Expected build warnings
 #
 ifeq ($(UNEXPECTED),1)
-CFLAGS += -DCHECK_UNEXPECTED
+override CFLAGS += -DCHECK_UNEXPECTED
 endif
 
 #
@@ -90,20 +123,14 @@
 
 ifneq ($(PRESERVE_CFLAGS),1)
 ifeq ($(findstring icc,$(CC)),icc)
-CFLAGS += -no-inline-max-size -no-inline-max-total-size
-CFLAGS += -axAVX,CORE-AVX2,CORE-AVX-I,CORE-AVX512,SSE2,SSE3,SSSE3,SSE4.1,SSE4.2,SANDYBRIDGE,SKYLAKE,SKYLAKE-AVX512,TIGERLAKE,SAPPHIRERAPIDS
-CFLAGS += -ip -falign-loops -funroll-loops -ansi-alias -fma -qoverride-limits
-endif
-endif
-
-ifeq ($(findstring gcc,$(CC)),gcc)
-ifneq ($(KERNEL),SunOS)
-CFLAGS += -ftree-loop-vectorize
+override CFLAGS += -no-inline-max-size -no-inline-max-total-size
+override CFLAGS += -axAVX,CORE-AVX2,CORE-AVX-I,CORE-AVX512,SSE2,SSE3,SSSE3,SSE4.1,SSE4.2,SANDYBRIDGE,SKYLAKE,SKYLAKE-AVX512,TIGERLAKE,SAPPHIRERAPIDS
+override CFLAGS += -ip -falign-loops -funroll-loops -ansi-alias -fma -qoverride-limits
 endif
 endif
 
 #ifeq ($(findstring clang,$(CC)),clang)
-#CFLAGS += -Weverything
+#override CFLAGS += -Weverything
 #endif
 
 GREP = grep
@@ -120,8 +147,8 @@
 # Static flags, only to be used when using GCC
 #
 ifeq ($(STATIC),1)
-LDFLAGS += -static -z muldefs
-CFLAGS += -DBUILD_STATIC
+override LDFLAGS += -static -z muldefs
+override CFLAGS += -DBUILD_STATIC
 endif
 
 BINDIR=/usr/bin
@@ -129,34 +156,67 @@
 JOBDIR=/usr/share/stress-ng/example-jobs
 BASHDIR=/usr/share/bash-completion/completions
 
+
 #
 # Header files
 #
 HEADERS = \
 	core-arch.h \
+	core-affinity.h \
 	core-asm-arm.h \
+	core-asm-generic.h \
+	core-asm-loong64.h \
 	core-asm-ppc64.h \
 	core-asm-riscv.h \
 	core-asm-s390.h \
 	core-asm-sparc.h \
 	core-asm-x86.h \
+	core-asm-ret.h \
+	core-attribute.h \
 	core-bitops.h \
 	core-builtin.h \
 	core-capabilities.h \
+	core-clocksource.h \
+	core-config-check.h \
 	core-cpu.h \
 	core-cpu-cache.h \
+	core-cpuidle.h \
 	core-ftrace.h \
 	core-hash.h \
-	core-icache.h \
+	core-ignite-cpu.h \
+	core-interrupts.h \
 	core-io-priority.h \
+	core-job.h \
+	core-helper.h \
+	core-killpid.h \
+	core-klog.h \
+	core-limit.h \
+	core-lock.h \
+	core-log.h \
+	core-madvise.h \
+	core-mlock.h \
+	core-mmap.h \
+	core-mincore.h \
+	core-module.h \
+	core-mounts.h \
+	core-mwc.h \
 	core-nt-load.h \
 	core-nt-store.h \
 	core-net.h \
+	core-numa.h \
+	core-opts.h \
+	core-out-of-memory.h \
+	core-parse-opts.h \
 	core-perf.h \
 	core-pragma.h \
+	core-processes.h \
 	core-pthread.h \
 	core-put.h \
 	core-resources.h \
+	core-sched.h \
+	core-setting.h \
+	core-shared-heap.h \
+	core-shim.h \
 	core-smart.h \
 	core-sort.h \
 	core-stressors.h \
@@ -164,8 +224,11 @@
 	core-target-clones.h \
 	core-thermal-zone.h \
 	core-thrash.h \
+	core-time.h \
+	core-try-open.h \
 	core-vecmath.h \
 	core-version.h \
+	core-vmstat.h \
 	stress-af-alg-defconfigs.h \
 	stress-eigen-ops.h \
 	stress-ng.h
@@ -184,6 +247,7 @@
 #
 STRESS_SRC = \
 	stress-access.c \
+	stress-acl.c \
 	stress-affinity.c \
 	stress-af-alg.c \
 	stress-aio.c \
@@ -202,6 +266,7 @@
 	stress-cache.c \
 	stress-cacheline.c \
 	stress-cap.c \
+	stress-cgroup.c \
 	stress-chattr.c \
 	stress-chdir.c \
 	stress-chmod.c \
@@ -236,6 +301,7 @@
 	stress-eventfd.c \
 	stress-exec.c \
 	stress-exit-group.c \
+	stress-factor.c \
 	stress-fallocate.c \
 	stress-fanotify.c \
 	stress-far-branch.c \
@@ -292,6 +358,7 @@
 	stress-l1cache.c \
 	stress-landlock.c \
 	stress-lease.c \
+	stress-led.c \
 	stress-link.c \
 	stress-list.c \
 	stress-llc-affinity.c \
@@ -315,6 +382,7 @@
 	stress-memrate.c \
 	stress-memthrash.c \
 	stress-mergesort.c \
+	stress-metamix.c \
 	stress-mincore.c \
 	stress-misaligned.c \
 	stress-mknod.c \
@@ -322,11 +390,13 @@
 	stress-mlockmany.c \
 	stress-mmap.c \
 	stress-mmapaddr.c \
+	stress-mmapfiles.c \
 	stress-mmapfixed.c \
 	stress-mmapfork.c \
 	stress-mmaphuge.c \
 	stress-mmapmany.c \
 	stress-module.c \
+	stress-monte-carlo.c \
 	stress-mprotect.c \
 	stress-mpfr.c \
 	stress-mq.c \
@@ -362,6 +432,7 @@
 	stress-poll.c \
 	stress-prctl.c \
 	stress-prefetch.c \
+	stress-prio-inv.c \
 	stress-priv-instr.c \
 	stress-procfs.c \
 	stress-pthread.c \
@@ -393,6 +464,7 @@
 	stress-rseq.c \
 	stress-rtc.c \
 	stress-sctp.c \
+	stress-schedmix.c \
 	stress-schedpolicy.c \
 	stress-seal.c \
 	stress-seccomp.c \
@@ -407,6 +479,7 @@
 	stress-shm.c \
 	stress-shm-sysv.c \
 	stress-sigabrt.c \
+	stress-sigbus.c \
 	stress-sigchld.c \
 	stress-sigfd.c \
 	stress-sigfpe.c \
@@ -420,6 +493,8 @@
 	stress-sigsegv.c \
 	stress-sigsuspend.c \
 	stress-sigtrap.c \
+	stress-sigxcpu.c \
+	stress-sigxfsz.c \
 	stress-skiplist.c \
 	stress-sleep.c \
 	stress-smi.c \
@@ -449,10 +524,12 @@
 	stress-tee.c \
 	stress-timer.c \
 	stress-timerfd.c \
+	stress-time-warp.c \
 	stress-tlb-shootdown.c \
 	stress-tmpfs.c \
 	stress-touch.c \
 	stress-tree.c \
+	stress-trig.c \
 	stress-tsc.c \
 	stress-tsearch.c \
 	stress-tun.c \
@@ -477,10 +554,13 @@
 	stress-vm-rw.c \
 	stress-vm-segv.c \
 	stress-vm-splice.c \
+	stress-vma.c \
+	stress-vnni.c \
 	stress-wait.c \
 	stress-waitcpu.c \
 	stress-watchdog.c \
 	stress-wcs.c \
+	stress-workload.c \
 	stress-x86cpuid.c \
 	stress-x86syscall.c \
 	stress-xattr.c \
@@ -489,16 +569,26 @@
 	stress-zlib.c \
 	stress-zombie.c \
 
+
+#
+#  Build time core source files
+#
+CORE_SRC_GEN = \
+	core-config.c
+
 #
 # Stress core
 #
 CORE_SRC = \
 	core-affinity.c \
+	core-asm-ret.c \
 	core-cpu.c \
 	core-cpu-cache.c \
+	core-cpuidle.c \
+	core-clocksource.c \
+	core-config-check.c \
 	core-hash.c \
 	core-helper.c \
-	core-icache.c \
 	core-ignite-cpu.c \
 	core-interrupts.c \
 	core-io-uring.c \
@@ -511,72 +601,3 @@
 	core-log.c \
 	core-madvise.c \
 	core-mincore.c \
-	core-mlock.c \
-	core-mmap.c \
-	core-module.c \
-	core-mounts.c \
-	core-mwc.c \
-	core-net.c \
-	core-numa.c \
-	core-out-of-memory.c \
-	core-parse-opts.c \
-	core-perf.c \
-	core-processes.c \
-	core-resources.c \
-	core-sched.c \
-	core-setting.c \
-	core-shared-heap.c \
-	core-shim.c \
-	core-smart.c \
-	core-sort.c \
-	core-thermal-zone.c \
-	core-time.c \
-	core-thrash.c \
-	core-ftrace.c \
-	core-try-open.c \
-	core-vmstat.c \
-	stress-ng.c
-
-SRC = $(CORE_SRC) $(STRESS_SRC)
-OBJS = apparmor-data.o
-OBJS += stress-eigen-ops.o
-OBJS += $(SRC:.c=.o)
-
-APPARMOR_PARSER=/sbin/apparmor_parser
-
-all: config.h stress-ng
-
-.SUFFIXES: .cpp .c .o
-
-.o: Makefile
-
-%.o: %.c $(HEADERS) $(HEADERS_GEN)
-	$(PRE_Q)echo "CC $<"
-	$(PRE_V)$(CC) $(CFLAGS) -c -o $@ $<
-
-#
-#  Use CC for linking if eigen is not being used, otherwise use CXX
-#
-stress-ng: config.h $(OBJS)
-	$(PRE_Q)echo "LD $@"
-	$(eval LINK_TOOL := $(shell if [ -n "$(shell grep '^#define HAVE_EIGEN' config.h)" ]; then echo $(CXX); else echo $(CC); fi))
-	$(eval LDFLAGS_EXTRA := $(shell cat config | grep CONFIG_LDFLAGS | sed 's/CONFIG_LDFLAGS += //' | tr '\n' ' '))
-	$(PRE_V)$(LINK_TOOL) $(OBJS) -lm $(LDFLAGS) $(LDFLAGS_EXTRA) -o $@
-
-stress-eigen-ops.o: config.h
-	@if grep -q '^#define HAVE_EIGEN' config.h; then \
-		echo "CXX stress-eigen-ops.cpp";	\
-		$(CXX) -c -o stress-eigen-ops.o stress-eigen-ops.cpp; \
-	else \
-		echo "CC stress-eigen-ops.c";	\
-		$(CC) -c -o stress-eigen-ops.o stress-eigen-ops.c; \
-	fi
-
-config.h config:
-	$(PRE_Q)echo "Generating config.."
-	$(MAKE) CC="$(CC)" STATIC=$(STATIC) -f Makefile.config
-
-makeconfig: config.h
-
-#
-#  generate apparmor data using minimal core utils tools from apparmor

=== debian/changelog ===
stress-ng (0.17.05-1) unstable; urgency=medium

  [Nikolas Kyx]
  * stress-syscall: fix cmp_test_duration() return value

  [Colin Ian King]
  * Makefile: bump version
  * Makefile: add core-asm-loong64.h to HEADERS
  * stress-atomic: make atomic region 64 bytes wide, step through it
  * Manual: update caveat concerning bogo-op rates
  * Manual: update date
  * stress-unshare: silently ignore EACCES returns
  * core-pragma: drop packed gcc version to 9.4
  * Manual: fix a couple of typos
  * stress-prio-inv: fix typo "cheduling" -> "scheduling"
  * core-helper: fix some spelling mistakes
  * stress-landlock: ensure all set bits work in mask and zero
    ruleset_attr before use
  * stress-sysfs: ignore SIGKILL as bad signal
  * stress-numa: fix one more %zu format specifier
  * stress-numa: use %zu format specifier for size_t
  * stress-monte-carlo: don't use getrandom for Solaris, it's very slow
  * core-vmstat: only account for CP_SPIN on OpenBSD if it exists
  * stress-stack: make rc no-clobberable, cleans up gcc 4.9.2 warning on
    kfreebsd
  * core-shim: disabled process_mrelease for SPARC
  * stress-monte-carlog: only define stress_mc_no_seed if it is required
  * core-perf: make filemap page cache description match existing style
  * stress-numa: report per instance mapping size to 1 decimal place
  * stress-numa: add --numa-bytes option to specify total memory size
  * kernel-coverage: add numa addr and node shuffling options
  * stress-numa: add --numa-shuffle-addr and --numa-shuffle-node
  * stress-numa: ensure pages get re-assigned to different nodes
  * stress-tree: disable warnings on misaligned pointer access
  * stress-numa: use stress_mmap_set_light to touch pages
  * core-pragma: add checks for gcc 10
  * core-pragma: add missing \
  * stress-monte-carlo: use generic supported and no_seed functions
  * stress-dev: add include ifdefs around stress_dev_ptp_linux
  * stress-dev: add macro VOID_ARGS to voidify common function args
  * stress-dev: remove UNEXPECTED checks, add more linux guarding
  * stress-dev: add some kvm ioctls
  * stress-dev: exercise UI_GET_VERSION ioctl on /dev/uinput
  * stress-dev: add RNDGETPOOL ioctl on /dev/random
  * stress-dev: exercise /dev/input/event*
  * stress-dev: add RTC RTC_IRQP_READ32 ioctl
  * stress-dev: add linux /dev/rtc ioctls, delay on -EBUSY
  * stress-mmap: add missing MMAP_SYNC flag
  * stress-ng.h: disable _FORTIFY_SOURCE when using PCC
  * stress-ng.h: disable _FORTIFY_SOURCE when using TCC
  * core-mmap: remove unused variable val
  * stress-sigsegv: make pointers uint8_t * to clean up void * pointer
    addition warnings
  * Makefile: don't enable -fipa for icc
  * stress-tree: allow tree node packed structures where packed is
    allowed on x86
  * core-pragma: add -Waddress-of-packed-member to WARN_OFF macro
  * core-attribute.h: add PACKED macro for attribute packed
  * stress-tree: move u into it's own typedef and make tree node 8 byte
    aligned
  * stress-tree: avl: remove redundant assignments to taller
  * stress-tree: avl: add pointer r as a short cut for (*root)
  * stress-tress: avl: make variable taller a register
  * stress-tree: avl: remove sub_taller variable
  * stress-tree: avl: replace (*root) with node on new node
  * stress-tree: don't pass taller flag in avl_insert
  * Add build-time test for packed attribute
  * README.md: add DEBUG=1 make build instructions
  * stress-monte-carlo: add some more complex integrals to compute
  * stress-monte-carlo: fix ppc64 darn and add missing rand support check
  * stress-rseq: add check for __builtin_thread_pointer()
  * stress-monte-carlo: add Monte Carlo computation of pi and e
  * stress-rseq: remove debug '| 1' for sys/rseq.h include
  * stress-rseq: remove trailing white space
  * stress-rseq: remove invalid rseq test cases
  * stress-rseq: remove rate debug
  * stress-rseq: move critical section count into a stressor metric
  * stress-rseq: rework to work with rseq in glibc
  * stress-sigsegv: fix exact fault address check
  * stress-x86syscall: add geteuid, getgid and getuid
  * README.md: add another citation link
  * stress-prio-inv: remove undef of PTHREAD_MUTEX_ROBUST
  * stress-prio-inv: remove prio default case from switch
  * stress-prio-inv: add build time check for pthread_mutexattr_setrobust
  * stress-prio-inv: add build-time checks for various SCHED_* support
  * stress-prio-inv: update reason why stressor is not implemented
  * stress-prio-inv: move pthread_mutex_t dependant types
  * Add shim for dirent d_type
  * stress-landlock: shift left with correct sized integer
  * Makefile.config: cater for empty $LIB_BSD string
  * stress-time-warp: add a time/clock time warp checking stressor
  * stress-prio-inv: match order of STRESS_PRIO_INV_POLICY_* with
    stress_prio_inv_policies
  * stress-mmap: add --mmap-stressful
  * stress-prio-inv: add --prio-inv-policy to select scheduler policy
  * stress-prio-inv: use FIFO sched by default
  * README.md: add Nikolas Kyx to contributors list
  * Add new prio-inv (priority inversion) stressor
  * stress-mmap: add --mmap-slow-munmap option
  * core-perf: add some more trace events
  * stress-landlock: only exercise flags that are usable
  * core-shim: replace strlcpy with safer strscpy
  * stress-landlock: add more landlock access flags, add check for
    usability
  * core-mwc: optimize and generalize mwc*modn() functions, remove pwr2
    helpers
  * stress-mmap: use non-mod random mwc functions for faster index
    generation
  * stress-mmap: add new option --mmap-write-check for opt-in write +
    checks
  * stress-factor: up the maximum digit size to 100000000 digits
  * stress-mmap: add --mmap2 option in short help
  * kernel-coverage: add new mmap options to mmap stress cases
  * stress-mmap: add opt-in randomized madvise on pages
  * core-mmap: touch + check just start of each page rather than filling
    them
  * debian/control: add libgmp-dev for factor stressor
